
# coding: utf-8

# ### Ricapitolazione Lez 8
# 
# - cos'è in dettaglio un file, come si interpreta, come leggerlo
# 
# - frequenza caratteri in un testo
# 
# - frequenza parole in un testo
# 
# - set
# 
# - lista come pila o coda
# 
# - array
# 
# - Esercizio su operazioni con notazione polacca. 

# # Lez 9

# ### Metodo per implementare un algoritmo
# 
# - identificare nell'algoritmo la azioni di base da eseguire
# - per ogni azione fornire un'implementazione e testarla con l'interprete python
# - fare una funzione e testarla
# - combinare le varie implementazioni
# - testare la funzione nell'interprete di python

# ### Soluzione Esercizio notazione polacca
# 
# ###### Algoritmo:
# 
# - Scannerizzare l’espressione da destra a sinistra
# 
# - per ogni simbolo:
# 
# 	- se il simbolo è un operando allora mettilo in una pila
#     
# 	- se è un operatore op allora:
#     
# 		- togli il primo elemento dalla pila e salvalo in x
#         
# 		- togli il primo elemento dalla pila e salvalo in y
#         
#         - spingi il risultato  x op y nella pila 
#             
# - ritorna la testa della pila come risultato
# 
# 
# ###### Task:
# 
# -1- scannerizzare l'espressione da destra a sinistra
# 
# -2- verificare se il simbolo è un operatore od un operando
# 
# -3- implementare le operazione di append e push e pop in python
# 
# -4- dato un operatore, eseguire l'operazione associata

# In[1]:

expr = '- * / 15 - 7 + 1 1 3 + 2 + 1 1'
l_expr=expr.split()
l_expr

1 - scannerizzare l'espressione da destra a sinistra
# In[2]:

for i in range(1,len(l_expr)+1):
    print(l_expr[len(l_expr)-i])


# In[3]:

for i in range(len(l_expr)-1,-1,-1):
    print(l_expr[i])


# In[5]:

l_expr.reverse()    
for i in l_expr:
    print(i)

2 - verificare se il simbolo è un operatore od un operando
# In[6]:

def isAnOperator( x ):                                 # ritorna True se x è ’+’,’−’,’∗’,’/’”””
    return (x=='+') or (x=='-') or (x=='*') or (x=='/')


# In[12]:

isAnOperator( '/' )

3- implementare le operazione di append e push e pop in python
# In[13]:

l_expr


# In[15]:

l_expr[3]


# In[16]:

pila = []
pila.append(int(l_expr[3]))
pila.append(int(l_expr[5]))
pila


# In[17]:

x = pila.pop()
y = pila.pop()


# In[18]:

y

-4- dato un operatore, eseguire l'operazione associata
# In[19]:

# calcola il valore dell'espressione ’x op y’, 
#dove x e y sono due interi e op è un operatore tra ’+’,’−’,’∗’,’/’””” 

def compute( op , x , y ):
    if (op=='+'):
        return x+y 
    elif op=='-':
        return x-y 
    elif op=='*':
        return x*y 
    elif op=='/':
        return x/y 
    else:
        return 0


# In[24]:

compute('/',5,6)


# In[25]:

l_expr


# In[26]:

stack = []
for i in range(len(l_expr)-1,-1,-1):
    print(l_expr[i])
    if isAnOperator( l_expr[i] ):
        stack.append( compute( l_expr[i] , stack.pop() , stack.pop() ) )
    else:
        stack.append( int(l_expr[i]) )
    print(stack)


# In[27]:

def evalPolishExpression( expr ):
    e=expr.split()
    pila = []
    for i in range(len(e)-1,-1,-1):
        if isAnOperator( e[i] ):
            pila.append( compute( e[i] , pila.pop() , pila.pop() ) )
        else:
            pila.append( int(e[i]) )
    return(pila.pop())


# In[28]:

evalPolishExpression( '- * / 15 - 7 + 1 1 3 + 2 + 1 1' )


# ## Ricorsione
# 
#  In python si possono definire funzioni che possa chiamare sé stesse. 

# In[30]:

def fib(n):
    if n <= 1:
        return n
    t = fib(n-1) + fib(n-2)
    return t


# In[31]:

for n in range(1,11):
    print(fib(n), end=' ')

Frattali, e.g. Kockdef Ricorsione(): 
  Ricorsione()
# ### List comprehensions
# 
# S = {x² : x in {0 ... 9}}
# 
# V = (1, 2, 4, 8, ..., 2¹²)
# 
# M = {x | x in S and x even}

# In[32]:

#   S = {x² : x in {0 ... 9}}
S = [x**2 for x in range(10)]
S


# In[33]:

S = []
for x in range(10):
    S.append(x**2)
S


# In[36]:

# V = (1, 2, 4, 8, ..., 2¹²)
V = [2**i for i in range(13)]
V


# In[38]:

# M = {x | x in S and x even}
M = [x for x in S if x % 2 == 0]
M


# In[39]:

# combinare elementi di due liste se non sono uguali
[(x, y) for x in [1,2,3] for y in [3,1,4] if x != y]


# In[40]:

combs = []
for x in [1,2,3]:
    for y in [3,1,4]:
        if x != y:
            combs.append((x, y))
combs


# In[41]:

matrix = [
    [1, 2, 3, 4],
    [5, 6, 7, 8],
    [9, 10, 11, 12],
]
matrix    


# #### Ex: 
# Calcolare la matrice trasposta

# In[45]:

[[row[i] for row in matrix] for i in range(len(matrix[0]))]


# ### Lambda per scrivere piccole funzioni

# In[46]:

somma = lambda x,y : x+y


# In[47]:

somma(2,3)


# Con lambda posso creare piccole funzioni anonime, la funzione è una solo espressione e non si possono usare if, else, for,..! Se l'espressione diventa troppo complicata conviene definire la funzione in modo standard

# In[48]:

### pot=x^2
pot = lambda x: x**2


# In[49]:

pot(4)


# ### map  
# map(funzione, sequenza) 
# 
# Chiama la funzione(elem) per ogni elemento della sequenza e ritorna una mappa del valori. Usando poi lista ritrovi la lista dei valori.

# In[50]:

#   S = {x² : x in {0 ... 9}}
S = [x**2 for x in range(10)]
S


# In[51]:

S = list(map(pot, range(10)))
S


# In[53]:

S = list(map(lambda x: x**2, range(10)))
S


# ### Filter
# 
# filter(funzione_input, seq_input) 
# 
# ritorna una sequenza con i valori i della seq_input per cui funzione_input(i) è vera

# In[54]:

# M = {x | x in S and x even}
M = [x for x in S if x % 2 == 0]
M


# In[55]:

S


# In[56]:

list(filter( lambda x:  x % 2 == 0 , S ))


# In[ ]:



